package vn.hus.nlp.fsm.builder;

import java.io.PrintStream;
import java.util.Map;
import vn.hus.nlp.fsm.Configuration;
import vn.hus.nlp.fsm.FSM;
import vn.hus.nlp.fsm.ISimulator;
import vn.hus.nlp.fsm.State;
import vn.hus.nlp.fsm.Transition;
import vn.hus.nlp.fsm.fsa.DFAConfiguration;
import vn.hus.nlp.fsm.fst.FSTConfiguration;

public class SimpleFSMBuilder extends FSMBuilder
{
  public SimpleFSMBuilder(String paramString)
  {
    super(paramString);
  }

  protected void addItem(String paramString, String[] paramArrayOfString)
  {
    Configuration localConfiguration = getSimulator().track(paramString);
    Object localObject1 = localConfiguration.getCurrentState();
    String str1 = "";
    Object localObject2;
    if ((localConfiguration instanceof DFAConfiguration))
    {
      localObject2 = (DFAConfiguration)localConfiguration;
      str1 = ((DFAConfiguration)localObject2).getUnprocessedInput();
    }
    if ((localConfiguration instanceof FSTConfiguration))
    {
      localObject2 = (FSTConfiguration)localConfiguration;
      str1 = ((FSTConfiguration)localObject2).getUnprocessedInput();
    }
    if (str1.length() > 0)
    {
      int i = this.machine.getStates().size();
      State localState = null;
      int j = (paramArrayOfString != null) && (paramArrayOfString.length > 0) ? 1 : 0;
      int k;
      char c;
      if (j == 0)
      {
        for (k = 0; k < str1.length(); k++)
        {
          c = str1.charAt(k);
          localState = new State(i + k);
          this.machine.addState(localState);
          this.machine.addTransition(new Transition(((State)localObject1).getId(), localState.getId(), c));
          localObject1 = localState;
        }
      }
      else
      {
        if (paramArrayOfString.length != paramString.length())
        {
          System.err.println("Error! The output must have the same length with its input.");
          System.exit(-1);
        }
        for (k = 0; k < str1.length(); k++)
        {
          c = str1.charAt(k);
          localState = new State(i + k);
          this.machine.addState(localState);
          String str2 = paramArrayOfString[(paramArrayOfString.length - str1.length() + k)];
          this.machine.addTransition(new Transition(((State)localObject1).getId(), localState.getId(), c, str2));
          localObject1 = localState;
        }
      }
      localState.setType((byte)2);
    }
    else
    {
      ((State)localObject1).setType((byte)2);
    }
  }

  protected void finalize()
  {
  }
}

/* Location:           C:\Downloads\vn.hus.nlp.tokenizer-4.1.1-bin.tar\lib\vn.hus.nlp.fsm-1.0.0.jar
 * Qualified Name:     vn.hus.nlp.fsm.builder.SimpleFSMBuilder
 * JD-Core Version:    0.6.0
 */