package vn.hus.nlp.utils;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public final class UTF8FileUtility
{
  public static BufferedWriter writer = null;
  public static BufferedReader reader = null;
  static List<FileListener> fileListeners = new ArrayList();

  public static void createReader(String paramString)
  {
    try
    {
      createReader(new FileInputStream(paramString));
    }
    catch (FileNotFoundException localFileNotFoundException)
    {
      localFileNotFoundException.printStackTrace();
    }
  }

  private static void createReader(InputStream paramInputStream)
  {
    try
    {
      closeReader();
      InputStreamReader localInputStreamReader = new InputStreamReader(paramInputStream, "UTF-8");
      reader = new BufferedReader(localInputStreamReader);
    }
    catch (UnsupportedEncodingException localUnsupportedEncodingException)
    {
      localUnsupportedEncodingException.printStackTrace();
    }
  }

  public static void closeReader()
  {
    try
    {
      if (reader != null)
      {
        reader.close();
        reader = null;
      }
    }
    catch (IOException localIOException)
    {
      localIOException.printStackTrace();
    }
  }

  public static void createWriter(String paramString)
  {
    try
    {
      createWriter(new FileOutputStream(paramString));
    }
    catch (FileNotFoundException localFileNotFoundException)
    {
      localFileNotFoundException.printStackTrace();
    }
  }

  private static void createWriter(OutputStream paramOutputStream)
  {
    try
    {
      closeWriter();
      OutputStreamWriter localOutputStreamWriter = new OutputStreamWriter(paramOutputStream, "UTF-8");
      writer = new BufferedWriter(localOutputStreamWriter);
    }
    catch (UnsupportedEncodingException localUnsupportedEncodingException)
    {
      localUnsupportedEncodingException.printStackTrace();
    }
  }

  public static void closeWriter()
  {
    try
    {
      if (writer != null)
      {
        writer.flush();
        writer.close();
        writer = null;
      }
    }
    catch (IOException localIOException)
    {
      localIOException.printStackTrace();
    }
  }

  private static String processTab(String paramString)
  {
    int i = paramString.indexOf(9);
    if (i > 0)
      return paramString.substring(0, i).trim();
    return paramString.trim();
  }

  public static String[] getLinesWithPOS(String paramString)
  {
    ArrayList localArrayList = new ArrayList();
    if (reader == null)
      createReader(paramString);
    String str1 = null;
    int i = 0;
    try
    {
      while ((str1 = reader.readLine()) != null)
      {
        i++;
        if (str1.trim().length() > 0)
        {
          String str2 = processTab(str1);
          if (str2.length() > 0)
            localArrayList.add(str2);
        }
        notify(str1, i);
      }
    }
    catch (IOException localIOException)
    {
      localIOException.printStackTrace();
    }
    closeReader();
    return (String[])localArrayList.toArray(new String[localArrayList.size()]);
  }

  public static String[] getLines(String paramString)
  {
    ArrayList localArrayList = new ArrayList();
    if (reader == null)
      createReader(paramString);
    String str = null;
    int i = 0;
    try
    {
      while ((str = reader.readLine()) != null)
      {
        i++;
        if (str.trim().length() > 0)
          localArrayList.add(str.trim());
        notify(str, i);
      }
    }
    catch (IOException localIOException)
    {
      localIOException.printStackTrace();
    }
    closeReader();
    return (String[])localArrayList.toArray(new String[localArrayList.size()]);
  }

  public static String[] getAllLines(String paramString)
  {
    ArrayList localArrayList = new ArrayList();
    if (reader == null)
      createReader(paramString);
    String str = null;
    int i = 0;
    try
    {
      while ((str = reader.readLine()) != null)
      {
        i++;
        localArrayList.add(str.trim());
        notify(str, i);
      }
    }
    catch (IOException localIOException)
    {
      localIOException.printStackTrace();
    }
    closeReader();
    return (String[])localArrayList.toArray(new String[localArrayList.size()]);
  }

  public static String readLine()
  {
    try
    {
      return reader.readLine().trim();
    }
    catch (IOException localIOException)
    {
      localIOException.printStackTrace();
    }
    return null;
  }

  public static void write(String paramString)
  {
    try
    {
      writer.write(paramString);
    }
    catch (IOException localIOException)
    {
      localIOException.printStackTrace();
    }
  }

  public static void writeln(String paramString)
  {
    try
    {
      writer.write(paramString);
      writer.write("\n");
    }
    catch (IOException localIOException)
    {
      localIOException.printStackTrace();
    }
  }

  public static void writeln(Object paramObject)
  {
    writeln(paramObject.toString());
  }

  public static void write(String[] paramArrayOfString)
  {
    for (int i = 0; i < paramArrayOfString.length; i++)
      writeln(paramArrayOfString[i]);
  }

  public static void write(Object[] paramArrayOfObject)
  {
    for (int i = 0; i < paramArrayOfObject.length; i++)
      writeln(paramArrayOfObject[i]);
  }

  public static void addFileListener(FileListener paramFileListener)
  {
    fileListeners.add(paramFileListener);
  }

  public static void removeFileListener(FileListener paramFileListener)
  {
    if (fileListeners.contains(paramFileListener))
      fileListeners.remove(paramFileListener);
  }

  public static void notify(String paramString, int paramInt)
  {
    Iterator localIterator = fileListeners.iterator();
    while (localIterator.hasNext())
    {
      FileListener localFileListener = (FileListener)localIterator.next();
      localFileListener.processed(paramString, paramInt);
    }
  }

  class Item
  {
    private String item;
    private String pos;

    public Item()
    {
      this.item = "";
      this.pos = "";
    }

    public Item(String paramString1, String arg3)
    {
      this.item = paramString1;
      this.pos = arg3;
    }

    public String getItem()
    {
      return this.item;
    }

    public String getPos()
    {
      return this.pos;
    }
  }
}

/* Location:           C:\Downloads\vn.hus.nlp.tokenizer-4.1.1-bin.tar\lib\vn.hus.nlp.utils-1.0.0.jar
 * Qualified Name:     vn.hus.nlp.utils.UTF8FileUtility
 * JD-Core Version:    0.6.0
 */